import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.IOException;

import javax.swing.JComponent;
import javax.swing.JList;
import javax.swing.TransferHandler;

import com.mindfusion.diagramming.DiagramView;


public class FormEditorTransferHandler extends TransferHandler
{
	public int getSourceActions(JComponent c)
	{
		return COPY;
	}
	
	protected Transferable createTransferable(JComponent c)
	{
		return new StringSelection(((JList)c).getSelectedValue().toString() );
	}
	
	protected void exportDone(JComponent c, Transferable t, int action)
	{
		
	}
	
	public boolean importData(JComponent c, Transferable t)
	{
		if (canImport(c, t.getTransferDataFlavors()))
		{
			// Can only drop on the flow chart control
			if (!(c instanceof DiagramView))
				return false;

			DiagramView flowChart = (DiagramView)c;

			if (t.isDataFlavorSupported(DataFlavor.stringFlavor))
			{
				try {
					_text = (String)t.getTransferData(DataFlavor.stringFlavor);
					
					_boxCreated = true;
				} catch (UnsupportedFlavorException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}

		return false;
	}
	
	public boolean canImport(JComponent c, DataFlavor[] flavors)
	{
		if (!(c instanceof DiagramView))
			return false;

		for (int i = 0; i < flavors.length; i++)
		{
			if (DataFlavor.stringFlavor.equals(flavors[i]))
				return true;
		}

		return false;
	}
	
	public static boolean isBoxCreated(){
		return _boxCreated;
	}

	public static void setBoxCreate(boolean is){
		_boxCreated = is;
	}
	
	public static String getText()
	{
		return _text;
	}
	
	public static void cleanText()
	{
		_text = "";
	}
	
	private static String _text = "";
	private static boolean _boxCreated = false;
}
