

package com.mindfusion.diagramming.samples.demo;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;


public class AddEntityDialog extends JDialog
{
	/**
	 * Initializes a new instance of the AddEntityDialog class with
	 * the specified parent. The dialog is centered within
	 * the parent.
	 */
	public AddEntityDialog(JFrame parent)
	{
		super(parent, true);

		_accepted = false;

		setTitle("Add New Entity");
		setSize(320, 320);
		setResizable(false);

		// Center in parent
		Rectangle parentBounds = new Rectangle();
		parent.getBounds(parentBounds);

		setLocation((parentBounds.width - getWidth()) / 2,
			(parentBounds.height - getHeight()) / 2);

		// Initialize frame
		initializeComponent();
	}

	/**
	 * Initializes child controls.
	 */
	private void initializeComponent()
	{
		setLayout(null);

		//
		// _lblName
		//
		_lblName = new JLabel();
		_lblName.setText("Name");
		_lblName.setLocation(8, 16);
		_lblName.setSize(72, 16);

		//
		// _txtName
		//
		_txtName = new JTextField();
		_txtName.setLocation(80, 14);
		_txtName.setSize(224, 20);

		//
		// _lblDescription
		//
		_lblDescription = new JLabel();
		_lblDescription.setText("Description");
		_lblDescription.setLocation(8, 40);
		_lblDescription.setSize(72, 16);

		//
		// _txtDescription
		//
		_txtDescription = new JTextArea();
		_txtDescription.setLineWrap(true);
		_txtDescription.setLocation(80, 40);
		_txtDescription.setSize(224, 96);

		//
		// _txtDescriptionScrollPane
		//
		_txtDescriptionScrollPane = new JScrollPane();
		_txtDescriptionScrollPane.setViewportView(_txtDescription);
		_txtDescriptionScrollPane.setLocation(80, 40);
		_txtDescriptionScrollPane.setSize(224, 96);

		//
		// _lblInput
		//
		_lblInput = new JLabel();
		_lblInput.setText("Input");
		_lblInput.setLocation(8, 144);
		_lblInput.setSize(72, 16);

		//
		// _chkRow1
		//
		_chkRow1 = new JCheckBox();
		_chkRow1.setLocation(8, 168);
		_chkRow1.setSize(24, 16);
		_chkRow1.setSelected(true);
		_chkRow1.addItemListener
		(
			new ItemListener()
			{
				public void itemStateChanged(ItemEvent e)
				{
					AddEntityDialog.this.onChkRow1(e);
				}
			}
		);

		//
		// _txtRow1
		//
		_txtRow1 = new JTextField();
		_txtRow1.setLocation(32, 166);
		_txtRow1.setSize(112, 20);

		//
		// _chkRow2
		//
		_chkRow2 = new JCheckBox();
		_chkRow2.setLocation(8, 192);
		_chkRow2.setSize(24, 16);
		_chkRow2.setSelected(true);
		_chkRow2.addItemListener
		(
			new ItemListener()
			{
				public void itemStateChanged(ItemEvent e)
				{
					AddEntityDialog.this.onChkRow2(e);
				}
			}
		);

		//
		// _txtRow2
		//
		_txtRow2 = new JTextField();
		_txtRow2.setLocation(32, 190);
		_txtRow2.setSize(112, 20);

		//
		// _chkRow3
		//
		_chkRow3 = new JCheckBox();
		_chkRow3.setLocation(8, 216);
		_chkRow3.setSize(24, 16);
		_chkRow3.setSelected(true);
		_chkRow3.addItemListener
		(
			new ItemListener()
			{
				public void itemStateChanged(ItemEvent e)
				{
					AddEntityDialog.this.onChkRow3(e);
				}
			}
		);

		//
		// _txtRow3
		//
		_txtRow3 = new JTextField();
		_txtRow3.setLocation(32, 214);
		_txtRow3.setSize(112, 20);

		//
		// _lblOutput
		//
		_lblOutput = new JLabel();
		_lblOutput.setText("Output");
		_lblOutput.setLocation(232, 144);
		_lblOutput.setSize(72, 16);

		//
		// _rbRow1
		//
		_rbRow1 = new JRadioButton();
		_rbRow1.setLocation(288, 168);
		_rbRow1.setSize(16, 16);
		_rbRow1.setSelected(true);
		_rbRow1.addItemListener
		(
			new ItemListener()
			{
				public void itemStateChanged(ItemEvent e)
				{
					AddEntityDialog.this.onRbRow1(e);
				}
			}
		);

		//
		// _txtRow1O
		//
		_txtRow1O = new JTextField();
		_txtRow1O.setLocation(160, 166);
		_txtRow1O.setSize(112, 20);

		//
		// _rbRow2
		//
		_rbRow2 = new JRadioButton();
		_rbRow2.setLocation(288, 192);
		_rbRow2.setSize(16, 16);
		_rbRow2.setSelected(false);
		_rbRow2.addItemListener
		(
			new ItemListener()
			{
				public void itemStateChanged(ItemEvent e)
				{
					AddEntityDialog.this.onRbRow2(e);
				}
			}
		);

		//
		// _txtRow2O
		//
		_txtRow2O = new JTextField();
		_txtRow2O.setLocation(160, 190);
		_txtRow2O.setSize(112, 20);
		_txtRow2O.setEnabled(false);

		//
		// _rbRow3
		//
		_rbRow3 = new JRadioButton();
		_rbRow3.setLocation(288, 216);
		_rbRow3.setSize(16, 16);
		_rbRow3.setSelected(false);
		_rbRow3.addItemListener
		(
			new ItemListener()
			{
				public void itemStateChanged(ItemEvent e)
				{
					AddEntityDialog.this.onRbRow3(e);
				}
			}
		);

		//
		// _txtRow3O
		//
		_txtRow3O = new JTextField();
		_txtRow3O.setLocation(160, 214);
		_txtRow3O.setSize(112, 20);
		_txtRow3O.setEnabled(false);

		//
		// _bgOutput
		//
		_bgOutput = new ButtonGroup();
		_bgOutput.add(_rbRow1);
		_bgOutput.add(_rbRow2);
		_bgOutput.add(_rbRow3);

		//
		// _btnAdd
		//
		_btnAdd = new JButton();
		_btnAdd.setText("Add");
		_btnAdd.setLocation(112, 256);
		_btnAdd.setSize(80, 24);
		_btnAdd.addActionListener
		(
			new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					AddEntityDialog.this.onBtnAdd(e);
				}
			}
		);

		Container contents = getContentPane();

		contents.add(_lblName);
		contents.add(_txtName);
		contents.add(_lblDescription);
		contents.add(_txtDescriptionScrollPane);
		contents.add(_lblInput);
		contents.add(_chkRow1);
		contents.add(_txtRow1);
		contents.add(_chkRow2);
		contents.add(_txtRow2);
		contents.add(_chkRow3);
		contents.add(_txtRow3);
		contents.add(_lblOutput);
		contents.add(_rbRow1);
		contents.add(_txtRow1O);
		contents.add(_rbRow2);
		contents.add(_txtRow2O);
		contents.add(_rbRow3);
		contents.add(_txtRow3O);
		contents.add(_btnAdd);
	}

	/**
	 * Handles the 'Add' button click.
	 */
	private void onBtnAdd(ActionEvent e)
	{
		_accepted = true;

		_name = null;
		_description = null;
		_input = new String[3];
		_output = new String[3];

		_input[0] = null;
		_input[1] = null;
		_input[2] = null;
		_output[0] = null;
		_output[1] = null;
		_output[2] = null;

		_name = _txtName.getText();
		_description = _txtDescription.getText();

		if (_chkRow1.isSelected())
			_input[0] = _txtRow1.getText();
		if (_chkRow2.isSelected())
			_input[1] = _txtRow2.getText();
		if (_chkRow3.isSelected())
			_input[2] = _txtRow3.getText();

		if (_rbRow1.isSelected())
			_output[0] = _txtRow1O.getText();
		else if (_rbRow2.isSelected())
			_output[1] = _txtRow2O.getText();
		else if (_rbRow3.isSelected())
			_output[2] = _txtRow3O.getText();

		hide();
	}

	/**
	 * Handles the itemStateChanged event on the first check box.
	 */
	private void onChkRow1(ItemEvent e)
	{
		if (e.getStateChange() == ItemEvent.DESELECTED)
			_txtRow1.setEnabled(false);
		else
			_txtRow1.setEnabled(true);
	}

	/**
	 * Handles the itemStateChanged event on the second check box.
	 */
	private void onChkRow2(ItemEvent e)
	{
		if (e.getStateChange() == ItemEvent.DESELECTED)
			_txtRow2.setEnabled(false);
		else
			_txtRow2.setEnabled(true);
	}

	/**
	 * Handles the itemStateChanged event on the third check box.
	 */
	private void onChkRow3(ItemEvent e)
	{
		if (e.getStateChange() == ItemEvent.DESELECTED)
			_txtRow3.setEnabled(false);
		else
			_txtRow3.setEnabled(true);
	}

	/**
	 * Handles the itemStateChanged event on the first radio button.
	 */
	private void onRbRow1(ItemEvent e)
	{
		if (e.getStateChange() == ItemEvent.DESELECTED)
			_txtRow1O.setEnabled(false);
		else
			_txtRow1O.setEnabled(true);
	}

	/**
	 * Handles the itemStateChanged event on the second radio button.
	 */
	private void onRbRow2(ItemEvent e)
	{
		if (e.getStateChange() == ItemEvent.DESELECTED)
			_txtRow2O.setEnabled(false);
		else
			_txtRow2O.setEnabled(true);
	}

	/**
	 * Handles the itemStateChanged event on the first radio button.
	 */
	private void onRbRow3(ItemEvent e)
	{
		if (e.getStateChange() == ItemEvent.DESELECTED)
			_txtRow3O.setEnabled(false);
		else
			_txtRow3O.setEnabled(true);
	}


	/**
	 * Gets whether the user has confirmed the dialog.
	 */
	public boolean getAccepted() { return _accepted; }

	/**
	 * Gets the name of the entity.
	 */
	public String getEntityName() { return _name; }

	/**
	 * Gets the description of the entity.
	 */
	public String getEntityDescription() { return _description; }

	/**
	 * Gets the text of the specified input or null if the
	 * input is to be disabled.
	 */
	public String getInput(int index) { return _input[index]; }

	/**
	 * Gets the text of the specified output or null if the
	 * output is to be disabled.
	 */
	public String getOutput(int index) { return _output[index]; }


	private boolean _accepted;

	private JLabel _lblName;
	private JTextField _txtName;
	private JLabel _lblDescription;
	private JTextArea _txtDescription;
	private JScrollPane _txtDescriptionScrollPane;
	private JLabel _lblInput;
	private JCheckBox _chkRow1;
	private JTextField _txtRow1;
	private JCheckBox _chkRow2;
	private JTextField _txtRow2;
	private JCheckBox _chkRow3;
	private JTextField _txtRow3;
	private JLabel _lblOutput;
	private JRadioButton _rbRow1;
	private JTextField _txtRow1O;
	private JRadioButton _rbRow2;
	private JTextField _txtRow2O;
	private JRadioButton _rbRow3;
	private JTextField _txtRow3O;
	private ButtonGroup _bgOutput;
	private JButton _btnAdd;

	private String _name;
	private String _description;
	private String[] _input;
	private String[] _output;
}
